//+------------------------------------------------------------------+
//|                                               SuperTrend nrp.mq4 |
//|                                                                  |
//| original Super trend for metatrader made by Jason Robinson       |
//| calculation correction, repainting solving and mtf by mladen     |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    atrPeriod        = 60;
extern double atrMultiplier    = 2.00;
extern bool   Interpolate      = true;

extern string _                = "alerts settings";
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double Trend[];
double trendhu[];
double trendhd[];
double trendhbu[];
double trendhbd[];
double Up[];
double Dn[];
double Direction[];

//
//
//
//
//

int    timeFrame;
string IndicatorFileName;
bool   ReturningBars;
bool   CalculatingStr;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,trendhu);  SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,trendhd);  SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,trendhbu); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,trendhbd); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,Trend);
      SetIndexBuffer(5,Up);
      SetIndexBuffer(6,Dn);
      SetIndexBuffer(7,Direction);

      //
      //
      //
      //
      //
         
         IndicatorFileName = WindowExpertName();
         CalculatingStr    = (TimeFrame=="CalculateStr"); if (CalculatingStr) return(0);
         ReturningBars     = (TimeFrame=="returnBars");   if (ReturningBars)  return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
      //
      //
      //
      //
      //
   
    IndicatorShortName("SuperTrendX_Candles "+timeFrameToString(timeFrame));
return(0);    
}

int deinit() {   return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars  = IndicatorCounted(); 
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
          int limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //
   //
   //
   //
   //
   //

   if (CalculatingStr || timeFrame==Period())
   {      
      for(int i=limit; i>=0; i--)
      {
         double atr    = iATR(NULL,0,atrPeriod,i);
         double cprice = Close[i];
         double mprice = iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN,i);
                Up[i]  = mprice+atrMultiplier*atr;
                Dn[i]  = mprice-atrMultiplier*atr;
         
         //
         //
         //
         //
         //

         Direction[i] = Direction[i+1];
            if (cprice > Up[i+1]) Direction[i] =  1;
            if (cprice < Dn[i+1]) Direction[i] = -1;
            if (Direction[i] == 1) 
            { 
              Dn[i]       = MathMax(Dn[i],Dn[i+1]); 
              Trend[i]    = Dn[i]; 
              trendhu[i]  = High[i];  trendhd[i] = Low[i]; 
              trendhbu[i] = MathMax(Open[i],Close[i]);
              trendhbd[i] = MathMin(Open[i],Close[i]);
            }
            if (Direction[i] ==-1)               
            { 
              Up[i]       = MathMin(Up[i],Up[i+1]);
              Trend[i]    = Up[i]; 
              trendhd[i]  = High[i];  trendhu[i] = Low[i]; 
              trendhbu[i] = MathMin(Open[i],Close[i]);
              trendhbd[i] = MathMax(Open[i],Close[i]);
            } 
            
      }
      manageAlerts();
      return(0);
   }

   //
   //
   //
   //
   //
   
   if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Direction[i] = iCustom(NULL,timeFrame,IndicatorFileName,"CalculateStr",atrPeriod,atrMultiplier,7,y);
         Trend[i]     = iCustom(NULL,timeFrame,IndicatorFileName,"CalculateStr",atrPeriod,atrMultiplier,4,y);
         if (Direction[i] == 1) 
         { 
           Dn[i]      = MathMax(Dn[i],Dn[i+1]); 
           Trend[i]   = Dn[i]; 
           trendhu[i] = High[i];  trendhd[i] = Low[i]; 
           trendhbu[i]= MathMax(Open[i],Close[i]);
           trendhbd[i]= MathMin(Open[i],Close[i]);
         }
         if (Direction[i] ==-1)               
         { 
           Up[i]    = MathMin(Up[i],Up[i+1]);
           Trend[i] = Up[i]; 
           trendhd[i] = High[i];  trendhu[i] = Low[i]; 
           trendhbu[i] = MathMin(Open[i],Close[i]);
           trendhbd[i] = MathMax(Open[i],Close[i]);
         }
   } 
manageAlerts();
return(0);
}

//
//
//
//
//

void manageAlerts()
{
   if (!CalculatingStr && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (Trend[whichBar] != Trend[whichBar+1])
      {
         if (Trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (Trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SuperTrend changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SuperTrend "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}